function init(varargin)
% FUNCTION fc_simesh.init()
%   Initializes the toolbox/package .
%
% <COPYRIGHT>
  p = inputParser;
  p.addParamValue('verbose',0,@isscalar);
  p.addParamValue('without',{},@iscell); % to avoid recursion
  p.parse(varargin{:});
  R=p.Results;
  env=fc_simesh.environment();
  if isdir(env.hypermesh_dir), addpath(env.hypermesh_dir);rehash path;end
  try
    fc_hypermesh.init(varargin{:})
  catch ME
    fprintf('[fc-simesh] Unable to load the fc-hypermesh toolbox!\n')
    %fprintf('[fc-simesh] Use fc_simesh.configure(''hypermesh_dir'',<DIR>) to correct this issue\n\n');
    rethrow(ME)
  end
  if isdir(env.oogmsh_dir), addpath(env.oogmsh_dir);rehash path;end
  try
    fc_oogmsh.init(varargin{:})
  catch ME
    fprintf('[fc-simesh] Unable to load the fc-oogmsh toolbox!\n')
    %fprintf('[fc-simesh] Use fc_simesh.configure(''oogmsh_dir'',<DIR>) to correct this issue\n\n');
    rethrow(ME)
  end
  
  if isempty(env.siplt_dir)
    fprintf('[fc-simesh] No graphical toolbox installed!\n')
  else
    if isdir(env.siplt_dir), addpath(env.siplt_dir);rehash path;end
      if ~ismember('fc-siplt',R.without)
      try
        fc_siplt.init(varargin{:},'without',{'fc-simesh'})
      catch ME
        fprintf('[fc-simesh] Unable to load the fc-siplt toolbox!\n')
        rethrow(ME)
      end
    end
  end
  
  if p.Results.verbose>0
    fprintf('Using fc-simesh toolbox [%s]:\n',fc_simesh.version());
  end
end  